package cmd

import (
	"kpt-pasture/dep"

	"gitee.com/xuyiping_admin/pkg/logger/zaplog"
	"github.com/spf13/cobra"
	"go.uber.org/zap"
)

// ConsumerCmd represents the consumer command
var ConsumerCmd = &cobra.Command{
	Use:   "consumer",
	Short: "start consumer",
	Run: func(cmd *cobra.Command, args []string) {
		srv := dep.DIAsynqWorkOrder()
		if err := srv.Server.Run(srv.Mux); err != nil {
			zaplog.Error("consumer", zap.Any("err", err))
		}
	},
}
