package middleware

import (
	"kpt-pasture/dep"
	"kpt-pasture/module/backend"

	"github.com/gin-gonic/gin"
)

const KeyDep = "key:dep"

func WithDependency(s *dep.HttpDependency) gin.HandlerFunc {
	return func(c *gin.Context) {
		c.Set(KeyDep, s)
		c.Next()
	}
}

func Dependency(c *gin.Context) *dep.HttpDependency {
	return c.MustGet(KeyDep).(*dep.HttpDependency)
}

func BackendOperation(c *gin.Context) *backend.Hub {
	return &(Dependency(c).StoreEventHub)
}
