package route

import (
	"kpt-pasture/http/handler/goods"

	"github.com/gin-gonic/gin"
)

func GoodsManageAPI(opts ...func(engine *gin.Engine)) func(s *gin.Engine) {
	return func(s *gin.Engine) {
		for _, opt := range opts {
			opt(s)
		}
		// goods API 组  物品管理
		goodsRoute := authRouteGroup(s, "/api/v1/goods/")
		// 药品相关
		goodsRoute.POST("/drugs/list", goods.DrugsList)
		goodsRoute.POST("/drugs/createOrUpdate", goods.DrugsCreateOrUpdate)
		// 医疗器械相关
		goodsRoute.POST("/medical/equipment/list", goods.MedicalEquipmentList)
		goodsRoute.POST("/medical/equipment/createOrUpdate", goods.MedicalEquipmentCreateOrUpdate)
		// 脖环相关
		goodsRoute.POST("/neck/ring/list", goods.NeckRingList)
		goodsRoute.POST("/neck/ring/createOrUpdate", goods.NeckRingCreateOrUpdate)
		// 出库相关
		goodsRoute.POST("/outbound/apply", goods.OutboundApply)
		goodsRoute.POST("/outbound/list", goods.OutboundList)
		goodsRoute.POST("/outbound/audit", goods.OutboundAudit)
		goodsRoute.POST("/outbound/cancel", goods.OutboundAudit)
		goodsRoute.GET("/outbound/detail/:id", goods.OutboundDetail)

		// 冻精
		goodsRoute.POST("/frozen/seme/list", goods.FrozenSemeList)
		goodsRoute.POST("/frozen/seme/create", goods.FrozenSemeCreate)
	}
}
