package model

import pasturePb "gitee.com/xuyiping_admin/go_proto/proto/go/backend/cow"

type CowSameTime struct {
	Id             int64                         `json:"id"`
	SameTimeId     int64                         `json:"sameTimeId"`
	CowId          int64                         `json:"cowId"`
	Lact           int32                         `json:"lact"`
	SameTimeStatus pasturePb.SameTimeStatus_Kind `json:"sameTimeStatus"`
	CreatedAt      int64                         `json:"createdAt"`
	UpdatedAt      int64                         `json:"updatedAt"`
}

func (c *CowSameTime) TableName() string {
	return "cow_same_time"
}

func NewCowSameTime(cow *Cow, sameTime *SameTime) *CowSameTime {
	return &CowSameTime{
		SameTimeId:     sameTime.Id,
		CowId:          cow.Id,
		Lact:           cow.Lact,
		SameTimeStatus: pasturePb.SameTimeStatus_No_Start,
	}
}

func NewCowSameTimeList(cowList []*Cow, sameTime *SameTime) []*CowSameTime {
	sameTimeCowList := make([]*CowSameTime, 0)
	for _, cow := range cowList {
		sameTimeCowList = append(sameTimeCowList, NewCowSameTime(cow, sameTime))

	}
	return sameTimeCowList
}
