package model

import pasturePb "gitee.com/xuyiping_admin/go_proto/proto/go/backend/cow"

const (
	ProactivelyStopBreedingForBackup = "proactively_stop_breeding_for_backup" // 后备牛主动停配
	ProactivelyStopBreedingForAdult  = "proactively_stop_breeding_for_adult"  // 成母牛主动停配
	PregnantCheckForFirst            = "pregnant_check_for_first"             // 怀孕检查-第一次
	PregnantCheckForSecond           = "pregnant_check_for_second"            // 怀孕检查-第二次
	PregnancyAge                     = "pregnancy_age"                        // 怀孕天数
	WeaningAge                       = "weaning_age"                          // 断奶天数

	ValueTypeFixed = 1 // 固定值
	ValueTypeRange = 2 // 范围值
)

var PregnantCheckNameKeyMap = map[string]string{
	PregnantCheckForFirst:  "初检",
	PregnantCheckForSecond: "复检",
}

var PregnantCheckNameValueMap = map[int32]string{
	1: "pregnant_check_for_first",
	2: "pregnant_check_for_second",
}

type SystemBasic struct {
	Id           int32                 `json:"id"`
	Name         string                `json:"name"`
	CategoryName string                `json:"categoryName"`
	CategoryId   int32                 `json:"categoryId"`
	MinValue     int32                 `json:"minValue"`
	MaxValue     int32                 `json:"maxValue"`
	WeekValue    pasturePb.Week_Kind   `json:"weekValue"`
	ValueType    int8                  `json:"valueType"`
	Remarks      string                `json:"remarks"`
	IsShow       pasturePb.IsShow_Kind `json:"isShow"`
	CreatedAt    int64                 `json:"createdAt"`
	UpdatedAt    int64                 `json:"updatedAt"`
}

func (s *SystemBasic) TableName() string {
	return "system_basic"
}
