package asynq

import (
	"context"
	"kpt-pasture/config"
	"kpt-pasture/service/asynqsvc"
	"kpt-pasture/service/redis"
	"kpt-pasture/store/kptstore"

	"gitee.com/xuyiping_admin/pkg/di"
	"github.com/hibiken/asynq"
	"go.uber.org/dig"
)

var Module = di.Options(di.Provide(NewJob))

func NewJob(entry Entry) BizExec {
	return &entry
}

type Entry struct {
	dig.In
	Cfg         *config.AppConfig
	DB          *kptstore.DB
	AsynqClient asynqsvc.Client
	Redis       *redis.CacheStoreRedisEntry
}

type BizExec interface {
	DayWorkOrder(ctx context.Context, t *asynq.Task) error
}
