package backend

import (
	"kpt-pasture/model"

	pasturePb "gitee.com/xuyiping_admin/go_proto/proto/go/backend/cow"
)

func (s *StoreEntry) BarnTypeEnumList() []*pasturePb.ConfigOptionsList {
	barnTypeList := make([]*pasturePb.ConfigOptionsList, 0)
	barnTypeList = append(barnTypeList, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.PenType_Lactating_Calves),
		Label:    "哺乳牛舍",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.PenType_Weaned_Calves),
		Label:    "断奶牛舍",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.PenType_Youth),
		Label:    "育成牛舍",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.PenType_Nurturing),
		Label:    "育成牛舍",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.PenType_Lactation),
		Label:    "泌乳牛舍",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.PenType_Peripartum),
		Label:    "围产牛舍",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.PenType_Dry_Milking),
		Label:    "干奶牛舍",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.PenType_Sick_Cow),
		Label:    "病牛舍",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.PenType_Out),
		Label:    "淘汰牛舍",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.PenType_Segregate),
		Label:    "隔离牛舍",
		Disabled: true,
	})

	return barnTypeList
}

func (s *StoreEntry) BreedStatusEnumList() []*pasturePb.ConfigOptionsList {
	breedStatusList := make([]*pasturePb.ConfigOptionsList, 0)
	breedStatusList = append(breedStatusList, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.BreedStatus_UnBreed),
		Label:    "未配",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.BreedStatus_Breeding),
		Label:    "已配未检",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.BreedStatus_Pregnant),
		Label:    "怀孕",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.BreedStatus_Empty),
		Label:    "空怀",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.BreedStatus_Calving),
		Label:    "产犊",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.BreedStatus_Abort),
		Label:    "流产",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.BreedStatus_No_Mating),
		Label:    "禁配",
		Disabled: true,
	})
	return breedStatusList
}

func (s *StoreEntry) CowKindEnumList() []*pasturePb.ConfigOptionsList {
	cowKindList := make([]*pasturePb.ConfigOptionsList, 0)
	cowKindList = append(cowKindList, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowKind_XMTEN),
		Label:    "西门塔尔牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowKind_AGSN),
		Label:    "安格斯牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowKind_XNLN),
		Label:    "夏洛莱牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowKind_LMZN),
		Label:    "利木赞牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowKind_HFTN),
		Label:    "海福特牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowKind_HN),
		Label:    "和牛",
		Disabled: true,
	})
	return cowKindList
}

func (s *StoreEntry) CowSourceEnumList() []*pasturePb.ConfigOptionsList {
	cowSourceList := make([]*pasturePb.ConfigOptionsList, 0)
	cowSourceList = append(cowSourceList, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowSource_Calving),
		Label:    "产犊",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowSource_Transfer_In),
		Label:    "调入",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowSource_Buy),
		Label:    "购买",
		Disabled: true,
	})
	return cowSourceList
}
func (s *StoreEntry) CowTypeEnumList(optionName, isAll string) []*pasturePb.ConfigOptionsList {
	cowTypeList := make([]*pasturePb.ConfigOptionsList, 0)
	if isAll == model.IsAllYes {
		cowTypeList = append(cowTypeList, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.CowType_Invalid),
			Label:    "全部",
			Disabled: true,
		})
	}
	if optionName == "breed" {
		cowTypeList = append(cowTypeList, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.CowType_Reserve_Calf),
			Label:    "后备牛",
			Disabled: true,
		}, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.CowType_Breeding_Calf),
			Label:    "经产牛",
			Disabled: true,
		})
		return cowTypeList
	}

	cowTypeList = append(cowTypeList, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Lactating_Calf),
		Label:    "哺乳犊牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Weaned_Calf),
		Label:    "育成牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Youth_Calf),
		Label:    "青年牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Fattening_Calf),
		Label:    "育肥牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Reserve_Calf),
		Label:    "后备牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Breeding_Calf),
		Label:    "种母牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Breeding_Bull),
		Label:    "种公牛",
		Disabled: true,
	})

	return cowTypeList
}

func (s *StoreEntry) SameTimeCowTypeEnumList(isAll string) []*pasturePb.ConfigOptionsList {
	cowTypeList := make([]*pasturePb.ConfigOptionsList, 0)
	if isAll == model.IsAllYes {
		cowTypeList = append(cowTypeList, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.SameTimeStatus_Invalid),
			Label:    "全部",
			Disabled: true,
		})
	}
	cowTypeList = append(cowTypeList, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.SameTimeCowType_Empty),
		Label:    "空怀牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.SameTimeCowType_Breeding_Calf),
		Label:    "种母牛",
		Disabled: true,
	})
	return cowTypeList
}

func (s *StoreEntry) SameTimeTypeEnumList(isAll string) []*pasturePb.ConfigOptionsList {
	cowTypeList := make([]*pasturePb.ConfigOptionsList, 0)
	if isAll == model.IsAllYes {
		cowTypeList = append(cowTypeList, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.SameTimeStatus_Invalid),
			Label:    "全部",
			Disabled: true,
		})
	}
	cowTypeList = append(cowTypeList, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.SameTimeType_PGBJ),
		Label:    "PG保健",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.SameTimeType_PGTQ),
		Label:    "PG同期",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.SameTimeType_RnGH),
		Label:    "RnGH",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.SameTimeType_TAI),
		Label:    "TAI输精",
		Disabled: true,
	})
	return cowTypeList
}

func (s *StoreEntry) ImmunizationCowTypeEnumList(isAll string) []*pasturePb.ConfigOptionsList {
	cowTypeList := make([]*pasturePb.ConfigOptionsList, 0)
	cowTypeList = append(cowTypeList, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Lactating_Calf),
		Label:    "犊牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Weaned_Calf),
		Label:    "育成牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Youth_Calf),
		Label:    "青年牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Fattening_Calf),
		Label:    "育肥牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Reserve_Calf),
		Label:    "后备牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Reserve_Calf),
		Label:    "种母牛",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.CowType_Breeding_Bull),
		Label:    "种公牛",
		Disabled: true,
	})
	return cowTypeList
}

func (s *StoreEntry) ImmunizationConditionsEnumList(isAll string) []*pasturePb.ConfigOptionsList {
	cowTypeList := make([]*pasturePb.ConfigOptionsList, 0)
	if isAll == model.IsAllYes {
		cowTypeList = append(cowTypeList, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.ImmunizationConditions_Invalid),
			Label:    "全部",
			Disabled: true,
		})
	}
	cowTypeList = append(cowTypeList, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.ImmunizationConditions_Days_Age),
		Label:    "日龄",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.ImmunizationConditions_Days_After_Delivery),
		Label:    "产后天数",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.ImmunizationConditions_Days_Of_Pregnancy),
		Label:    "怀孕天数",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.ImmunizationConditions_Admission_Days),
		Label:    "入场天数",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.ImmunizationConditions_Other_Vaccine_After),
		Label:    "基于其他疫苗之后",
		Disabled: true,
	})
	return cowTypeList
}

func (s *StoreEntry) TransferPenEnumList(isAll string) []*pasturePb.ConfigOptionsList {
	transferPenList := make([]*pasturePb.ConfigOptionsList, 0)
	if isAll == model.IsAllYes {
		transferPenList = append(transferPenList, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.TransferPenReason_Invalid),
			Label:    "全部",
			Disabled: true,
		})
	}
	transferPenList = append(transferPenList, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.TransferPenReason_Normal),
		Label:    "正常转群",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.TransferPenReason_Feed),
		Label:    "饲喂转群",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.TransferPenReason_Dry_Milk),
		Label:    "干奶转群",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.TransferPenReason_Pregnant),
		Label:    "怀孕转群",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.TransferPenReason_Overantibody),
		Label:    "过抗转群",
		Disabled: true,
	})
	return transferPenList
}

func (s *StoreEntry) ChildNumberEnumList(isAll string) []*pasturePb.ConfigOptionsList {
	configOptions := make([]*pasturePb.ConfigOptionsList, 0)
	if isAll == model.IsAllYes {
		configOptions = append(configOptions,
			&pasturePb.ConfigOptionsList{
				Value:    int32(pasturePb.ChildNumber_Invalid),
				Label:    "全部",
				Disabled: true,
			})
	}
	configOptions = append(configOptions,
		&pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.ChildNumber_One),
			Label:    "单胎",
			Disabled: true,
		}, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.ChildNumber_Two),
			Label:    "双胎",
			Disabled: true,
		}, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.ChildNumber_Three),
			Label:    "三胎",
			Disabled: true,
		}, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.ChildNumber_Four),
			Label:    "四胎",
			Disabled: true,
		})
	return configOptions
}

func (s *StoreEntry) CalvingLevelEnumList(isAll string) []*pasturePb.ConfigOptionsList {
	configOptions := make([]*pasturePb.ConfigOptionsList, 0)
	if isAll == model.IsAllYes {
		configOptions = append(configOptions,
			&pasturePb.ConfigOptionsList{
				Value:    int32(pasturePb.CalvingLevel_Invalid),
				Label:    "全部",
				Disabled: true,
			})
	}
	configOptions = append(configOptions,
		&pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.CalvingLevel_Natural_Childbirth),
			Label:    "自然分娩",
			Disabled: true,
		}, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.CalvingLevel_Artificial_Midwifery1),
			Label:    "人工助产(1-2人)",
			Disabled: true,
		}, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.CalvingLevel_Artificial_Midwifery2),
			Label:    "人工助产(3人以上)",
			Disabled: true,
		}, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.CalvingLevel_Caesarean_Section),
			Label:    "剖腹产",
			Disabled: true,
		})
	return configOptions
}

func (s *StoreEntry) DystociaReasonEnumList(isAll string) []*pasturePb.ConfigOptionsList {
	configOptions := make([]*pasturePb.ConfigOptionsList, 0)
	if isAll == model.IsAllYes {
		configOptions = append(configOptions,
			&pasturePb.ConfigOptionsList{
				Value:    int32(pasturePb.DystociaReason_Invalid),
				Label:    "全部",
				Disabled: true,
			})
	}
	configOptions = append(configOptions,
		&pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.DystociaReason_Malposition),
			Label:    "胎位不正",
			Disabled: true,
		}, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.DystociaReason_Fetal_Overgrowth),
			Label:    "胎儿过大",
			Disabled: true,
		}, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.DystociaReason_Uterine_Atony),
			Label:    "子宫收缩无力",
			Disabled: true,
		}, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.DystociaReason_Pelvic_Stenosis),
			Label:    "盆骨狭小",
			Disabled: true,
		}, &pasturePb.ConfigOptionsList{
			Value:    int32(pasturePb.DystociaReason_Sub_Health),
			Label:    "母牛亚健康状态",
			Disabled: true,
		})
	return configOptions
}

func (s *StoreEntry) PregnantCheckResultEnumList(isAll string) []*pasturePb.ConfigOptionsList {
	configOptions := make([]*pasturePb.ConfigOptionsList, 0)
	if isAll == model.IsAllYes {
		configOptions = append(configOptions,
			&pasturePb.ConfigOptionsList{
				Value:    int32(pasturePb.PregnantCheckResult_Invalid),
				Label:    "全部",
				Disabled: true,
			})
	}
	configOptions = append(configOptions, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.PregnantCheckResult_Pregnant),
		Label:    "有胎",
		Disabled: true,
	}, &pasturePb.ConfigOptionsList{
		Value:    int32(pasturePb.PregnantCheckResult_UnPregnant),
		Label:    "无胎",
		Disabled: true,
	})
	return configOptions
}
