package mqtt

import (
	"kpt-pasture/config"
	"kpt-pasture/store/kptstore"

	"gitee.com/xuyiping_admin/pkg/di"
	golangMqtt "github.com/eclipse/paho.mqtt.golang"
	"go.uber.org/dig"
)

var Module = di.Options(di.Provide(NewDataEvent))

type DataEvent interface {
	NewMqtt(configOption config.MqttSetting) golangMqtt.Client
	SubMsg(configOption config.MqttSetting, client golangMqtt.Client)
}

type DataEventEntry struct {
	dig.In

	DB *kptstore.DB // DB
}

func NewDataEvent(entry DataEventEntry) DataEvent {
	return &entry
}
