package mqtt2

import (
	"gitee.com/xuyiping_admin/pkg/logger/zaplog"
	"go.uber.org/zap"
)

func (s *MqttClient) Producer(top string, qos int32, data []byte) error {
	if token := s.Client.Publish(top, byte(qos), false, data); token.Wait() && token.Error() != nil {
		zaplog.Error("producer", zap.String("topic", top), zap.String("data", string(data)), zap.Any("err", token.Error()))
		return token.Error()
	}
	return nil
}
